<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on October 2, 2006 at 5:41:03 pm</time-stamp>
<!-- Changes from: PV-DM-Support(Guam.3,dwilliam)  to: PV-DM-Support (Guam.4,sourcecontrol)+ -->


<methods>
<class-id>PROVISO.RelationsCollection</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="asRelationsWith:">asRelationsWith: anObject 
	
	^(self anySatisfy: [:each | each isEquivalentRelation: anObject]) 
		ifFalse: [self copyWith: anObject]</body>

<body package="PV-DM-Support" selector="asRelationsWithout:">asRelationsWithout: anObject
	" Answer the receiver, considered as a
	collection of dependents, with the first
	occurrence of anObject (if any) removed.
	If anObject does not occur in the receiver,
	answer the receiver. "
	" If there is only one dependent left,
	just answer it, rather than a new Collection. "

	| newCollection item size indx |
	size := self size.
	size = 2 ifTrue:
		[((self at: 1) isEquivalentRelation: anObject)
			ifTrue: [^self at: 2]
			ifFalse:
				[((self at: 2) isEquivalentRelation: anObject)
					ifTrue: [^self at: 1]
					ifFalse: [^self]]].

	newCollection := self class new: size - 1.
	indx := 1.
	" Search until we find an occurrence of
	anObject, or until we have copied all but
	the last item in the collection. "
	[indx = size or:
	  [item := self at: indx.
	  item isEquivalentRelation: anObject]]
		whileFalse:
			[newCollection at: indx put: item.
			indx := indx + 1].
	indx = size
		ifTrue:
			[((self at: size) isEquivalentRelation: anObject)
				ifTrue: [^newCollection]
				ifFalse: [^self]]
		ifFalse: 
			[newCollection replaceFrom: indx to: size - 1 with: self startingAt: indx + 1.
			^newCollection]</body>
</methods>

<methods>
<class-id>PROVISO.PvRelation</class-id> <category>testing</category>

<body package="PV-DM-Support" selector="isEquivalentRelation:">isEquivalentRelation: anObject 
	
	^anObject isRelation and: 
		[self compositeId = anObject compositeId and: 
			[self memberId = anObject memberId and: 
				[self relationId = anObject relationId and: [self index = anObject index]]]]</body>
</methods>

<methods>
<class-id>PROVISO.PvRelation</class-id> <category>enumerating</category>

<body package="PV-DM-Support" selector="asRelationsWith:">asRelationsWith: anObject 
	
	^(self isEquivalentRelation: anObject) 
		ifTrue: [self]
		ifFalse: [super asRelationsWith: anObject]</body>
</methods>


</st-source>
