<?xml version="1.0"?>

<st-source>
<!-- Changes in change set QCIF_Patch -->
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on October 2, 2006 at 4:54:08 pm</time-stamp>


<methods>
<class-id>Core.CharacterArray class</class-id> <category>net strings</category>

<body package="NetStrings" selector="readStringOrIntegerNetStringIntoIntegerFrom:for:">readStringOrIntegerNetStringIntoIntegerFrom: strm for: anObject
	
	| size answer errParam aChar |
	size := strm readNetStringSize.
	answer := LargePositiveInteger basicNew: size - 1.
	aChar := strm next asCharacter.
	aChar = $+ 
		ifTrue: 
			[(1 to: size - 1) do: 
				[:i | 
				answer 
					digitAt: i
					put: strm next asCharacter asciiValue]]
		ifFalse: [answer := (aChar asString, (strm next: size - 1) asString) asInteger.
				self system 
					logWarning: #QCIF_MODEL_CORRECTION_UPDATE
					messageId: #PATCH
					text: anObject printString, '[New value: ', answer printString,']'].
	(aChar := strm next asCharacter) = $, 
		ifFalse: 
			[^InvalidNetString 
				raiseWith: (errParam := answer , aChar asString)
				errorString: 
					'invalid net string: missing comma at end of ' , errParam asByteArray storeString].
	^answer</body>
</methods>


<methods>
<class-id>PROVISO.UBA.RelationAdaptor</class-id> <category>accessing-meta data</category>

<body package="PVAdaptor-Adaptors" selector="optionalFieldAdaptors">optionalFieldAdaptors
	^(super optionalFieldAdaptors)
		at: #index
			put: ((FieldAdaptor new)
					compute: [:v | self value index: v value asInteger];
					yourself);
		at: #origin
			put: ((FieldAdaptor new)
					compute: [:v | self value origin: v smeeToPrimitiveString];
					yourself);
		yourself</body>
</methods>


<methods>
<class-id>PROVISO.PvRelation</class-id> <category>serilization</category>

<body package="PV-DM-Support" selector="repositoryReadFrom:">repositoryReadFrom: strm
	"Materialize the receiver's state from strm."

	super repositoryReadFrom: strm.
	(compositeId := Integer readNetStringFrom: strm) = -1 ifTrue: [compositeId := nil].
	(memberId := Integer readNetStringFrom: strm) = -1 ifTrue: [memberId := nil].
	(relationId := Integer readNetStringFrom: strm) = -1 ifTrue: [relationId := nil].
	(index := String readStringOrIntegerNetStringIntoIntegerFrom: strm for: self) = -1 ifTrue: [index := nil].
	(date := Integer readNetStringFrom: strm) = -1 ifTrue: [date := nil].
	(flags := Integer readNetStringFrom: strm) = -1 ifTrue: [flags := nil].
	(origin := (String readNetStringFrom: strm) asSymbol) = #nil ifTrue: [origin := nil].
	(user := (String readNetStringFrom: strm) asSymbol) = #nil ifTrue: [user := nil].</body>
</methods>


<methods>
<class-id>PROVISO.PvInventorySubelementManager</class-id> <category>database queries</category>

<body package="PV-NM-Inventory-Application" selector="dbLoadForCollectors:before:">dbLoadForCollectors: collectors before: seconds 
	
	self dbLoadFamilies.
	self pvModel repository ifNotNil: [self pvModel recoverRepository].
	self fixQcifRepository.
	(self pvModel repository isNil or: [self itemCount = 0]) 
		ifTrue: [self pvModel lastEndSeconds: 0].
	self 
		dbResyncItems: collectors
		between: self pvModel lastEndSeconds
		and: seconds</body>

<body package="PV-NM-Inventory-Application" selector="fixQcifRepository">fixQcifRepository
	
	self pvModel subelementManager allItems do: 
		[:each | 
		each hasRelations 
			ifTrue: 
				[self system 
					logWarning: #QCIF_MODEL_CORRECTION
					messageId: #PATCH
					text: each printString.
				each saveIn: pvModel]].
	self system 
		logWarning: #QCIF_MODEL_CORRECTION_COMPLETED
		messageId: #PATCH
		text: 'Stopping QCIF'.
	(Delay forSeconds: 3) wait.
	self currentApplication stopImmediate</body>
</methods>



</st-source>
